﻿using System;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
  [StorableClass]
  public abstract class DTLZ : MultiObjectiveTestFunction {


    public override IEnumerable<double[]> OptimalParetoFront(int objectives) {
      if (objectives == 2) return PFStore.get(this.ItemName);
      throw new NotImplementedException();
    }

    public override double[,] Bounds(int objectives) {
        return new double[,] { { 0, 1 } };
    }

    public override bool[] Maximization(int objectives) {
      return new bool[objectives];
    }

    public override int MinimumSolutionLength {
      get { return 2; }
    }
    public override int MaximumSolutionLength {
      get {return int.MaxValue;}
    }


    public override int MinimumObjectives {
      get { return 2; }
    }
    public override int MaximumObjectives {
      get {return int.MaxValue;}
    }

    public override double[] ReferencePoint(int objectives) {
      double[] rp = new double[objectives];
      for(int i = 0; i< objectives; i++) {
        rp[i] = 11;
      }
      return rp;
    }

    [StorableConstructor]
    protected DTLZ(bool deserializing) : base(deserializing) { }
    protected DTLZ(DTLZ original, Cloner cloner) : base(original, cloner) {}
    public DTLZ() : base() {
    }

    public abstract override double[] Evaluate(RealVector r, int objecitves);

  }
}
